#!/usr/bin/python3
"""
  The main function of this file is a sample which downloads a page and
  then uploads it to the W3C validator.
"""

def main():
    import tempfile, sys, os, urllib.request, urllib.error, urllib.parse, MultipartPostHandler

    validatorURL = "http://validator.w3.org/check"
    opener = urllib.request.build_opener(MultipartPostHandler.MultipartPostHandler)

    def validateFile(url):
        temp = tempfile.mkstemp(suffix=".html")
        os.write(temp[0], opener.open(url).read())
        # use the encoding of the uploaded page in open().read().decode()
        params = { "ss" : "0",            # show source
                   "doctype" : "Inline",
                   "uploaded_file" : open(temp[1], "rb").read().decode('utf-8') }
        # use the encoding of the validator here
        print(opener.open(validatorURL, params).read().decode('utf-8'))
        os.remove(temp[1])

    if len(sys.argv[1:]) > 0:
        for arg in sys.argv[1:]:
            validateFile(arg)
    else:
        validateFile("http://www.python.org")

if __name__=="__main__":
    main()
